import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.applet.*;
import javax.swing.*;
import java.net.*;

import java.io.*;
import java.io.IOException;

public class DGListener implements DragGestureListener {

	private URL codeBase = null;
	/**
	 * Sets up the dglistener with a reference to the applet codebase
	 */
	 public DGListener(URL codebase) {
	 	codeBase = codebase;
	 }

	/**
	 * A drag gesture has been initiated and this essentially allows it
	 * to be begun
	 */
	public void dragGestureRecognized(DragGestureEvent event) {

		//do some stuff so that we can create the dragable cursor
		Toolkit toolkit = event.getComponent().getToolkit();
		TransferableImage tImage = (TransferableImage)event.getComponent();
		LogicGate gate = (LogicGate)tImage.getTransferData(tImage.getTransferDataFlavors()[0]);

		Cursor dragCursor = gate.getCursorRepresentation(toolkit, codeBase);

		event.getDragSource().startDrag(event, dragCursor,
								(Transferable)event.getComponent(),
								event.getDragSource().getDragSourceListeners()[0]);
	}
}