import java.awt.*;
import java.awt.image.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.applet.*;
import javax.swing.*;
import java.net.*;

import java.io.*;
import java.io.IOException;

public class DSListener implements DragSourceListener {

	private URL codeBase = null;

	/**
	 * Creates the DSListener with a reference to the applet codebase
	 */
	public DSListener(URL codebase) {
		codeBase = codebase;
	}

    /**
     * this message goes to DragSourceListener, informing it that the dragging
     * has entered the DropSite
     */
    public void dragEnter(DragSourceDragEvent event) {
    	Transferable transferable = event.getDragSourceContext().getTransferable();
		DataFlavor f = new DataFlavor(TransferableImage.class, "TransferableImage");
        Image i = event.getDragSourceContext().getComponent().createImage(75,50);

        try {
        	// we accept only TransferableImages
  	     	if (transferable.isDataFlavorSupported(f)) {
  	     		//so get this gates cusor representation
      			LogicGate gate = (LogicGate)transferable.getTransferData(f);
				Cursor c = gate.getCursorRepresentation(event.getDragSourceContext().getComponent().getToolkit(), codeBase);
				event.getDragSourceContext().setCursor(c);
			}
		}
		catch(UnsupportedFlavorException ufe) {
			System.err.println("Could not create customised cursor : UnsupportedFlavorException Error");
		}
		catch(IOException ioe) {
			System.err.println("Could not create customised cursor : IOException Error");
		}
    }

    /**
     * this message goes to DragSourceListener, informing it that the dragging is currently
     * ocurring over the DropSite
     */
    public void dragOver(DragSourceDragEvent event) {
    }

    /**
     * is invoked when the user changes the dropAction
     */
    public void dropActionChanged(DragSourceDragEvent event) {
    }

    /**
     * this message goes to DragSourceListener, informing it that the dragging
     * has exited the DropSite
     */
    public void dragExit(DragSourceEvent event) {
    }

    /**
     * this message goes to DragSourceListener, informing it that the dragging
     * has ended
     */
	public void dragDropEnd(DragSourceDropEvent event) {
  	}
}