import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.applet.*;
import javax.swing.*;

import java.io.*;
import java.io.IOException;
 
public class DTListener implements DropTargetListener {
	
	/**
	 * The drop circuit that this listener is registered to
	 */
	private DropTargetCircuit dropCircuit = null;
	
	/** 
	 * Creates a drop target listener which can be used to listen for drop events.
	 * The droptargetcircuit parent is required so that the drop can be added to it 
	 */
	public DTListener(DropTargetCircuit dropCircuitParent) {
		dropCircuit = dropCircuitParent;
	}
	
	/**
	 * Deals with the drag first entering the drop zone
	 */
    public void dragEnter(DropTargetDragEvent event) {
    }
    
    /**
     * Deals with the drag in the mid stage
     */
    public void dragOver(DropTargetDragEvent e) {
    }
    
    /**
     * deals with the drop action being changed mid-drop
     */
    public void dropActionChanged(DropTargetDragEvent e) {   
    }
    
    /**
     * Deals with a drag exiting the drop zone
     */
    public void dragExit(DropTargetEvent e) {
    }
    
    /**
     * Deals with a drop event happening
     */
	public void drop(DropTargetDropEvent e) {
	   	try {
        	Transferable transferable = e.getTransferable();
			DataFlavor f = new DataFlavor(TransferableImage.class, "TransferableImage");
        	
        	// we accept only TransferableImages
       		if (transferable.isDataFlavorSupported(f)){
        
           		e.acceptDrop(DnDConstants.ACTION_MOVE);
            	LogicGate gate = (LogicGate)transferable.getTransferData(f);
 
				((DropTargetCircuit)dropCircuit).dealWithDrop(gate,e.getLocation());

            	e.getDropTargetContext().dropComplete(true);
            	((DropTargetCircuit)dropCircuit).redrawScreen();
        	}
        	else{
           		e.rejectDrop();
        	}
    	}
    	catch (IOException exception) {
       		exception.printStackTrace();
        	System.err.println( "Exception" + exception.getMessage());
        	e.rejectDrop();
    	} 
    	catch (UnsupportedFlavorException ufException ) {
     	 	ufException.printStackTrace();
     		System.err.println( "Exception" + ufException.getMessage());
      		e.rejectDrop();
    	}
    }
}