import javax.swing.*;
import java.util.*;
import java.awt.Point;

/**
 * LogicCircuits.java 1.0 03/02/01
 *
 * Allows a dropboxlist to be created that contains drop box coordinates 
 *
 * <br><br>
 * Created      : 1/02/2003
 * <br><br>
 * Last Updated : 1/03/2003
 * <br><br>
 * 
 * @author   James McMahon
 */
public class DropBoxList {
	
	private ArrayList list = null;
	
	/** 
	 * Create an empty DropBoxList
	 */
	public DropBoxList() {
		list = new ArrayList();;
	}
	
	/**
	 * Adds the box to the list of all boxes
	 * 
	 * @param box The dropbox to be added
	 */
	public void addDropBoxtoList(DropBox box) {
		list.add(box);
	}
	
	/**
	 * Checks to see if point target is contained within the sphere of any of the 
	 * boxes in the list's boundaries.
	 * <p>
	 * If the point is in one of the boxes then it returns that box otherwise it returns null
	 * 
	 * @param target The point that is to be checked
	 * @return a dropbox that surrounds the target or null if one doesn't exist
	 */
	public DropBox getDropBoxContainingPoint(Point target) {

		ListIterator i = list.listIterator();
		
		while (i.hasNext()) {
			DropBox temp = (DropBox)i.next();
			if (temp.containsPoint(target)) {
				return temp;
			}
       	}
		return null;
	}
}