import java.awt.Dimension;
import java.lang.Exception;
import java.lang.String;
import java.net.URL;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;

/**
 * LogicCircuits.java 1.0 03/02/01
 * <br>
 * Author       : James McMahon
 * <br>
 * Logic Circuits Help Panel Class
 * <br>
 * Provides a help screen for users
 * <br>
 * Created      : 1/02/2003
 * <br>
 * Last Updated : 1/02/2003
 */
 
public class HelpPanel extends JEditorPane {
	
	/**
	 * name of the help file
	 */
	private String pageName = "help.html";
	
	/**
	 * url string for creating the actual URL type
	 */
	private String url = "";
	
	/**
	 * The url of the help page
	 */
	private URL helpURL = null;

	/**
	 * Initilise and shows a help page where the actual html help file
	 * is available at the end of the codeBase
	 * 
	 * @param   codeBase   The base of the applet code
	 */
	public HelpPanel(URL codeBase) {
		this.setEditable(false);

		try {
			url = codeBase+pageName;
			helpURL = new URL(url);
			this.setPage(helpURL);

			JScrollPane helpPanel = new JScrollPane(this);
			helpPanel.setPreferredSize(new Dimension(540,300));

			JOptionPane.showMessageDialog((JFrame)null,
						  helpPanel,
				          "Logic Circuit Resolution Help File",
				          JOptionPane.PLAIN_MESSAGE);

		} catch(Exception ioe) {
			//This is strange - if I catch the IOException that is supposed to be thrown then
			//it seems to ignore the actual exception that is generated - hence catching the general exception
			//is the only sure way of making the dialog being shown

			//So got a problem here with trying to open the html help page
			JOptionPane.showMessageDialog((JFrame)null,
						  "The help page can't be found - sorry!",
				          "Sorry there has been an error",
				          JOptionPane.ERROR_MESSAGE);
		}
	}
}