import java.awt.Dimension;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * LogicCircuits.java 1.0 03/02/01
 * Author       : James McMahon
 * <br>
 * Score Panel Class
 * <br>
 * Provides the score panel for the applet
 * <br>
 * Created      : 2/2/2003
 * <br>
 * Last Updated : 2/2/2003
 */
public class ScorePanel extends JPanel {
	
	/**
	 * Number of questions asked
	 */
	private int numAsked = 0;

    /*
	 * Number of questions answered correctly
	 */
	private int numRight = 0;
	
	/**
	 * The score label
	 */
	private JLabel score = new JLabel(""+numRight+" correct out of "+numAsked+"  ");

	/**
	 * Set up the score keeper by initilising it to asked 1 question with none right
	 */
	public ScorePanel() {
		this.setPreferredSize(new Dimension(150,50));
		this.setBorder(BorderFactory.createTitledBorder("Score Tracker"));
		this.add(score);
	}

	/**
	 * Reset the score to zero right out of 1 asked
	 */
	public void resetScore() {
		numAsked = 1; //Should always still be one question on screen
		numRight = 0;
		score.setText(""+numRight+" correct out of "+numAsked+"  ");
	}

	/**
	 * Adds one to the number of questions asked
	 */
	public void addQuestionAsked() {
		numAsked++;
		score.setText(""+numRight+" correct out of "+numAsked+"  ");
	}

	/**
	 * Adds one right answer, but doesn't update the number of questions asked
	 */
	public void addQuestionRight() {
		numRight++;
		score.setText(""+numRight+" correct out of "+numAsked+"  ");
	}
}