import java.lang.Class;
import java.lang.Object;
import java.lang.String;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;

/**
 * Modified code from the TableModel example on the java.sun.com swing tutorial pages
 */
public class TruthTableModel extends AbstractTableModel {
  	//table values (should be set by the constructor)
	private String[] columnNames;
	private Object[][] data;
	
	//number of fixed columns
	private int fixedColumns;

	//customises the data in the model
	public TruthTableModel(String[] columnTitles, Object[][] rowData, int numFixedColumns){
		columnNames = columnTitles;
  		data = rowData;
  		fixedColumns = numFixedColumns;
	}

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return data.length;
	}

	public String getColumnName(int col) {
		return columnNames[col];
	}

	public Object getValueAt(int row, int col) {
		return data[row][col];
	}

    /*
     * JTable uses this method to determine the default renderer/
     * editor for each cell.  If we didn't implement this method,
     * then the last column would contain text ("true"/"false"),
     * rather than a check box.
     */
	public Class getColumnClass(int c) {
		return getValueAt(0, c).getClass();
	}

    /*
     * Don't need to implement this method unless your table's
     * editable.
     * This table is editable for all but the first three columns
     */
	public boolean isCellEditable(int row, int col) {
	
	 //Note that the data/cell address is constant,
     //no matter where the cell appears onscreen.

     //MODIFIED CODE
     	if (col <= (fixedColumns-1)) {
     		return false;
     	}
     	else {
     	    return true; //All cells are editable except the first three which indicate
    	}
	}

    /*
     * Don't need to implement this method unless your table's
     * data can change.
     */
	public void setValueAt(Object value, int row, int col) {
		//MODIFIED CODE
	    //Only allows 1,0 or ? to be set in a cell

         if (value.toString().equals("0")
             | value.toString().equals("1")
             | value.toString().equals("?")) {

     	 	data[row][col] = value;
            fireTableCellUpdated(row, col);
         }
         else {
         	JOptionPane.showMessageDialog((JFrame)null,
            	        "You must enter either a 0 or a 1",
            	        "Invalid Input",
						JOptionPane.INFORMATION_MESSAGE);
         }
	}
}